"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const classnames_1 = (0, tslib_1.__importDefault)(require("classnames"));
const xor_1 = (0, tslib_1.__importDefault)(require("lodash/xor"));
const react_1 = (0, tslib_1.__importDefault)(require("react"));
const uniforms_1 = require("uniforms");
const wrapField_1 = (0, tslib_1.__importDefault)(require("./wrapField"));
const base64 = typeof btoa === 'undefined'
    ? /* istanbul ignore next */ /* istanbul ignore next */ x => Buffer.from(x).toString('base64')
    : btoa;
const escape = (x) => base64(encodeURIComponent(x)).replace(/=+$/, '');
function Select(_a) {
    var { allowedValues, checkboxes, disableItem, disabled, error, fieldType, id, inline, inputClassName, inputRef, label, name, onChange, placeholder, readOnly, required, transform, value } = _a, props = (0, tslib_1.__rest)(_a, ["allowedValues", "checkboxes", "disableItem", "disabled", "error", "fieldType", "id", "inline", "inputClassName", "inputRef", "label", "name", "onChange", "placeholder", "readOnly", "required", "transform", "value"]);
    const multiple = fieldType === Array;
    return (0, wrapField_1.default)(Object.assign(Object.assign({}, props), { id, label }), checkboxes ? (allowedValues === null || allowedValues === void 0 ? void 0 : allowedValues.map(item => (react_1.default.createElement("div", { key: item, className: (0, classnames_1.default)(inputClassName, `checkbox${inline ? '-inline' : ''}`) },
        react_1.default.createElement("label", { htmlFor: `${id}-${escape(item)}` },
            react_1.default.createElement("input", { checked: fieldType === Array ? value === null || value === void 0 ? void 0 : value.includes(item) : value === item, disabled: (disableItem === null || disableItem === void 0 ? void 0 : disableItem(item)) || disabled, id: `${id}-${escape(item)}`, name: name, onChange: () => {
                    if (!readOnly) {
                        onChange(fieldType === Array ? (0, xor_1.default)([item], value) : item);
                    }
                }, type: "checkbox" }),
            transform ? transform(item) : item))))) : (react_1.default.createElement("select", { className: (0, classnames_1.default)(inputClassName, 'form-control', {
            'form-control-danger': error,
        }), disabled: disabled, id: id, multiple: multiple, name: name, onChange: event => {
            if (!readOnly) {
                const item = event.target.value;
                if (multiple) {
                    const clear = event.target.selectedIndex === -1;
                    onChange(clear ? [] : (0, xor_1.default)([item], value));
                }
                else {
                    onChange(item !== '' ? item : undefined);
                }
            }
        }, ref: inputRef, value: value !== null && value !== void 0 ? value : '' },
        (!!placeholder || !required || value === undefined) && !multiple && (react_1.default.createElement("option", { value: "", disabled: required, hidden: required }, placeholder || label)), allowedValues === null || allowedValues === void 0 ? void 0 :
        allowedValues.map(value => (react_1.default.createElement("option", { disabled: disableItem === null || disableItem === void 0 ? void 0 : disableItem(value), key: value, value: value }, transform ? transform(value) : value))))));
}
exports.default = (0, uniforms_1.connectField)(Select, { kind: 'leaf' });
