import classnames from 'classnames';
import React from 'react';
import { connectField } from 'uniforms';
import wrapField from './wrapField';
const base64 = typeof btoa === 'undefined'
    ? /* istanbul ignore next */ /* istanbul ignore next */ x => Buffer.from(x).toString('base64')
    : btoa;
const escape = (x) => base64(encodeURIComponent(x)).replace(/=+$/, '');
function Radio(props) {
    var _a;
    return wrapField(props, (_a = props.allowedValues) === null || _a === void 0 ? void 0 : _a.map(item => (React.createElement("div", { key: item, className: classnames(props.inputClassName, `radio${props.inline ? '-inline' : ''}`) },
        React.createElement("label", { htmlFor: `${props.id}-${escape(item)}` },
            React.createElement("input", { checked: item === props.value, disabled: props.disabled, id: `${props.id}-${escape(item)}`, name: props.name, onChange: () => {
                    if (!props.readOnly) {
                        props.onChange(item);
                    }
                }, type: "radio" }),
            props.transform ? props.transform(item) : item)))));
}
export default connectField(Radio, { kind: 'leaf' });
