import { __rest } from "tslib";
import classnames from 'classnames';
import xor from 'lodash/xor';
import React from 'react';
import { connectField } from 'uniforms';
import wrapField from './wrapField';
const base64 = typeof btoa === 'undefined'
    ? /* istanbul ignore next */ /* istanbul ignore next */ x => Buffer.from(x).toString('base64')
    : btoa;
const escape = (x) => base64(encodeURIComponent(x)).replace(/=+$/, '');
function Select(_a) {
    var { allowedValues, checkboxes, disableItem, disabled, error, fieldType, id, inline, inputClassName, inputRef, label, name, onChange, placeholder, readOnly, required, transform, value } = _a, props = __rest(_a, ["allowedValues", "checkboxes", "disableItem", "disabled", "error", "fieldType", "id", "inline", "inputClassName", "inputRef", "label", "name", "onChange", "placeholder", "readOnly", "required", "transform", "value"]);
    const multiple = fieldType === Array;
    return wrapField(Object.assign(Object.assign({}, props), { id, label }), checkboxes ? (allowedValues === null || allowedValues === void 0 ? void 0 : allowedValues.map(item => (React.createElement("div", { key: item, className: classnames(inputClassName, `checkbox${inline ? '-inline' : ''}`) },
        React.createElement("label", { htmlFor: `${id}-${escape(item)}` },
            React.createElement("input", { checked: fieldType === Array ? value === null || value === void 0 ? void 0 : value.includes(item) : value === item, disabled: (disableItem === null || disableItem === void 0 ? void 0 : disableItem(item)) || disabled, id: `${id}-${escape(item)}`, name: name, onChange: () => {
                    if (!readOnly) {
                        onChange(fieldType === Array ? xor([item], value) : item);
                    }
                }, type: "checkbox" }),
            transform ? transform(item) : item))))) : (React.createElement("select", { className: classnames(inputClassName, 'form-control', {
            'form-control-danger': error,
        }), disabled: disabled, id: id, multiple: multiple, name: name, onChange: event => {
            if (!readOnly) {
                const item = event.target.value;
                if (multiple) {
                    const clear = event.target.selectedIndex === -1;
                    onChange(clear ? [] : xor([item], value));
                }
                else {
                    onChange(item !== '' ? item : undefined);
                }
            }
        }, ref: inputRef, value: value !== null && value !== void 0 ? value : '' },
        (!!placeholder || !required || value === undefined) && !multiple && (React.createElement("option", { value: "", disabled: required, hidden: required }, placeholder || label)), allowedValues === null || allowedValues === void 0 ? void 0 :
        allowedValues.map(value => (React.createElement("option", { disabled: disableItem === null || disableItem === void 0 ? void 0 : disableItem(value), key: value, value: value }, transform ? transform(value) : value))))));
}
export default connectField(Select, { kind: 'leaf' });
